/* ------------------------------------------------------------------------ */
/*                                                                          */
/*    FILE              : JavaJni.java                                      */
/*    PURPOSE           : Java code to interact with MDL                    */
/*    PART OF COMPONENT : Java-Mdl communication                            */
/*    CREATED BY        : Stanislav Sumbera, BERIT, Czech Republic          */
/*    DATE              : December 2000                                     */
/*    E-MAIL            : stanislav.sumbera@berit.cz                        */
/*                      : ambrosa@mendelu.cz                                */
/*    WWW               : http://www.sumbera.com                            */
/* ------------------------------------------------------------------------ */
import java.awt.*;
public class JavaJni extends Frame{
   Label                        label     = new Label ("",Label.CENTER);
   Button	                    button    = new Button("Call MDL function");
   Button	                    buttonVba = new Button("Call VBA method");
   Button	                    buttonNet = new Button("Call NET method");
   TextField                    mdl_limit = new TextField();
   TextField                    vba_limit = new TextField();
   TextField                    net_limit = new TextField();
   static JavaJni               javaObj   = new JavaJni("Java dialog");

static { 
// loading library nativeLib.dll
    System.loadLibrary("nativeLib");   
   }

// declaration of native function for MDL call
public native int callMdlFunc(short limit); 

// declaration of native function for VBA call
public native int callVbaMethod(short limit); 

// declaration of native function for NET call
public native int callNetMethod(short limit); 

public JavaJni(String title){  
// constructor to display a dialog box
   super(title); 
   resize(150,100);
   setBackground(SystemColor.control);
   setLayout(new GridLayout(4,3));
   add(button);    add(new Label("with number", Label.RIGHT)); add (mdl_limit);
   add(buttonVba); add(new Label("with number", Label.RIGHT)); add (vba_limit);
   add(buttonNet); add(new Label("with number", Label.RIGHT)); add (net_limit);
   mdl_limit.setText("500");
   vba_limit.setText("200");
   net_limit.setText("100");
   add(label);
   resize(300,150);
   show();
}


public int onMdlCall(short limit){ 
// reciever  method of a MDL call via DLL
 	label.setText("Java got: " +limit); 
	return 1;	
	}


public boolean action(Event evt, Object arg){
// invoker of MDL function via DLL when button is pressed
	if (evt.target == button){
			 
			 callMdlFunc((short)Integer.valueOf(mdl_limit.getText()).intValue());
	}
// invoker of VBA method  via DLL when button is pressed
		if (evt.target == buttonVba)
			 callVbaMethod((short)Integer.valueOf(vba_limit.getText()).intValue());

// invoker of NET method  via DLL when button is pressed
		if (evt.target == buttonNet)
			 callNetMethod((short)Integer.valueOf(net_limit.getText()).intValue());

		return true;
	}
	
	
	
public boolean handleEvent(Event evt){
		if (evt.id == Event.WINDOW_DESTROY){
			this.dispose();
			//System.exit(0); // exit under MicroStation  creates exeption
			return true;
		}
    return super.handleEvent(evt);
}

public static void main(String[] args)   {
           javaObj.show();	
  }
}
