/* ------------------------------------------------------------------------ */
/*                                                                          */
/*    FILE              : MdlCode.mc                                        */
/*    PURPOSE           : MDL code to invoke Java                           */
/*                                                                          */
/*    PART OF COMPONENT : interop communication                             */
/*    CREATED BY        : Stanislav Sumbera,                                */
/*    DATE              : 02/2002	                                        */
/*    E-MAIL            : stanislav@sumbera.com,ambrosa@mendelu.cz          */
/*    WWW               : http://www.sumbera.com                            */
/* ------------------------------------------------------------------------ */
#include <stdio.h>
#include <dlogids.h>
#include <msdialog.fdf>
#include <mswindow.fdf>
#include <ditemlib.fdf>
#include <mscexpr.fdf>
#include <msparse.fdf>

#include <msrmgr.h>
#include    "MdlCode.h"	   
#include    "MdlCoCmd.h"   



// declaration of native functions 
nativeCode int dll_setMdlFuncCall(ULong);
nativeCode int dll_callJavaMethod(short);
nativeCode int dll_callVbaMethod(short);
nativeCode int dll_callNetMethod(short);


Private MdlCode mdlCode;
/*----------------------------------------------------------- */
int mdlOnCall ( short   limit)
/*----------------------------------------------------------- */
// This function is called via DLL by Java
{
    char    message[255];
	DialogItem            *diP         = NULL;
    DialogBox             *dbP         = mdlDialog_find(DIALOGID_MdlCode,NULL);
  
	sprintf(message,"MDL got: %d",limit);
	if (!dbP){
		printf(message);
		return !SUCCESS;
	}
	diP = mdlDialog_itemGetByTypeAndId (dbP, RTYPE_Label, LABEL_RECIEVER_ID, 0);
    if (diP)
      mdlDialog_itemSetLabel(dbP,diP->itemIndex,message);

    return TRUE;
}

/*----------------------------------------------------------- */
Public void CALLJAVA(char *limit)
/*----------------------------------------------------------- */
cmdNumber CMD_CALLJAVA
// MicroStation command to run Java method via DLL
{
	dll_callJavaMethod((short)mdlCode.javaLimit); // call a Java method via dll
}

/*----------------------------------------------------------- */
Public void CALLVBA(char *limit)
/*----------------------------------------------------------- */
cmdNumber CMD_CALLVBA
// MicroStation command to run Java method via DLL
{

	dll_callVbaMethod((short)mdlCode.vbaLimit); // call a VBA method via dll
}

/*----------------------------------------------------------- */
Public void CALLNET(char *limit)
/*----------------------------------------------------------- */
cmdNumber CMD_CALLNET
// MicroStation command to run NET
{

	dll_callNetMethod((short)mdlCode.netLimit); // call a NET method via dll
}
/*----------------------------------------------------------- */
Public void main(int argc,char *argv[])
/*----------------------------------------------------------- */
{
   char	    *setP;	/* a ptr to a "C expression symbol set" */
   RscFileHandle    rscFileH;	/* a resource file handle */
   DialogBox	    *dbP;	/* a ptr to a dialog box */

   mdlCode.javaLimit = 40;
   mdlCode.vbaLimit = 50;
	// set a fucntion hook for DLL
   dll_setMdlFuncCall((ULong) mdlOnCall ); 

   /* open the resource file that we came out of */
   mdlResource_openFile (&rscFileH, NULL, 0);

   /* load the command table */
  mdlParse_loadCommandTable (NULL);
	
  setP = mdlCExpression_initializeSet (VISIBILITY_DIALOG_BOX, 0, FALSE);
  mdlDialog_publishComplexVariable (setP, "mdlcode", "mdlCode", &mdlCode);

   /* open the "Basic" dialog box */
   dbP = mdlDialog_open (NULL, DIALOGID_MdlCode);
   return ;
 

}
