/*                                                                          */
/*    FILE              : NETForm.cs                                         */
/*    PURPOSE           : .NET Form code                                    */
/*    PART OF COMPONENT : interop communication                             */
/*    CREATED BY        : Stanislav Sumbera,                                */
/*    DATE              : 02/2002	                                        */
/*    E-MAIL            : stanislav@sumbera.com,ambrosa@mendelu.cz          */
/*    WWW               : http://www.sumbera.com                            */
/* ------------------------------------------------------------------------ */

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

using System.Data;
using System.Runtime.InteropServices;
using System.Text;
using System.Reflection;
using Microsoft.Win32;


namespace NETobject
{
    public delegate void OnNETCallDelegate(int limit);
	public class DLLWrap
	{
		public static NetForm    netFormRef;
        public static OnNETCallDelegate  OnNETCallRef = new OnNETCallDelegate(DLLWrap.OnNETCall);
		// functions
		[DllImport("nativeLib.dll", CharSet=CharSet.Ansi, CallingConvention=CallingConvention.StdCall)]
		public static extern int dll_callMdlFunc(short limit); 

		[DllImport("nativeLib.dll", CharSet=CharSet.Ansi, CallingConvention=CallingConvention.StdCall)]
		public static extern int dll_callVbaMethod(short limit);

		[DllImport("nativeLib.dll", CharSet=CharSet.Ansi, CallingConvention=CallingConvention.StdCall)]
		public static extern int dll_callJavaMethod(short limit);

		[DllImport("nativeLib.dll", CharSet=CharSet.Ansi, CallingConvention=CallingConvention.StdCall)]
		public static extern int dll_setNetMethodCall(OnNETCallDelegate method); 

		[DllImport("ustation.dll", CharSet=CharSet.Ansi, CallingConvention=CallingConvention.Cdecl)]
		public static extern int mdlDialog_openInfoBox(String message); 

		
		public static void OnNETCall(int limit){ 
//			MessageBox.Show("NET got call back");
			netFormRef.setLimitToNetForm(limit);
			return ;
		}
	
	}

		

	public delegate void onTransmitDelegateMdl(int limit);
	public delegate void onTransmitDelegateJava(int limit);
	public delegate void onTransmitDelegateVba(int limit);

	/// <summary>
	/// Summary description for NetForm.
	/// </summary>
	[GuidAttribute("007AE90C-69E8-4200-8AF1-57D090238546")]
	[InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIDispatch)]
	public interface ITransmitEvent
	{
		[DispId(1)]
		void OnTransmitEventMdl(int limit);
		[DispId(2)]
		void OnTransmitEventJava(int limit);
		[DispId(3)]
		void OnTransmitEventVba(int limit);
	}
	[GuidAttribute("03008600-65F8-431c-8213-696AFF97CC22")]
	[InterfaceType(ComInterfaceType.InterfaceIsDual)]
	public interface ITransmit 
	{
		[DispId(1)]
		int setLimitToNetForm(int limit);
	}

	[ComSourceInterfaces(typeof(ITransmitEvent))]
	[ClassInterface(ClassInterfaceType.AutoDual)]
	public class NetForm : System.Windows.Forms.Form,ITransmit
	{
        MicroStationDGN.Application  msApps =  new MicroStationDGN.Application();

		private System.Windows.Forms.Button ButtonMdl;
		private System.Windows.Forms.Button ButtonJava;
		private System.Windows.Forms.Button ButtonCallVba;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox TextLimitMdl;
		private System.Windows.Forms.TextBox TextLimitJava;
		private System.Windows.Forms.TextBox TextLimitVBA;
		private System.Windows.Forms.Label LabelRec;
        private System.Windows.Forms.Button ButtonTestMDL;
        private System.Windows.Forms.Button ButtonTestMSDGN;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public event onTransmitDelegateMdl  OnTransmitEventMdl;
		public event onTransmitDelegateJava OnTransmitEventJava;
		public event onTransmitDelegateVba  OnTransmitEventVba;


		public NetForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			DLLWrap.netFormRef = this;
			DLLWrap.dll_setNetMethodCall(DLLWrap.OnNETCallRef);
            

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.ButtonMdl = new System.Windows.Forms.Button();
            this.ButtonJava = new System.Windows.Forms.Button();
            this.ButtonCallVba = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.TextLimitMdl = new System.Windows.Forms.TextBox();
            this.TextLimitJava = new System.Windows.Forms.TextBox();
            this.TextLimitVBA = new System.Windows.Forms.TextBox();
            this.LabelRec = new System.Windows.Forms.Label();
            this.ButtonTestMDL = new System.Windows.Forms.Button();
            this.ButtonTestMSDGN = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // ButtonMdl
            // 
            this.ButtonMdl.Location = new System.Drawing.Point(8, 8);
            this.ButtonMdl.Name = "ButtonMdl";
            this.ButtonMdl.Size = new System.Drawing.Size(104, 24);
            this.ButtonMdl.TabIndex = 0;
            this.ButtonMdl.Text = "Call Mdl Function";
            this.ButtonMdl.Click += new System.EventHandler(this.ButtonMdl_Click);
            // 
            // ButtonJava
            // 
            this.ButtonJava.Location = new System.Drawing.Point(8, 32);
            this.ButtonJava.Name = "ButtonJava";
            this.ButtonJava.Size = new System.Drawing.Size(104, 24);
            this.ButtonJava.TabIndex = 1;
            this.ButtonJava.Text = "Call Java Method";
            this.ButtonJava.Click += new System.EventHandler(this.ButtonJava_Click);
            // 
            // ButtonCallVba
            // 
            this.ButtonCallVba.Location = new System.Drawing.Point(8, 56);
            this.ButtonCallVba.Name = "ButtonCallVba";
            this.ButtonCallVba.Size = new System.Drawing.Size(104, 24);
            this.ButtonCallVba.TabIndex = 2;
            this.ButtonCallVba.Text = "Call VBA method";
            this.ButtonCallVba.Click += new System.EventHandler(this.ButtonCallVba_Click);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(118, 14);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(56, 16);
            this.label1.TabIndex = 3;
            this.label1.Text = "with value";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(118, 38);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(56, 16);
            this.label2.TabIndex = 4;
            this.label2.Text = "with value";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(118, 62);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(56, 16);
            this.label3.TabIndex = 5;
            this.label3.Text = "with value";
            // 
            // TextLimitMdl
            // 
            this.TextLimitMdl.Location = new System.Drawing.Point(184, 8);
            this.TextLimitMdl.Name = "TextLimitMdl";
            this.TextLimitMdl.Size = new System.Drawing.Size(40, 20);
            this.TextLimitMdl.TabIndex = 6;
            this.TextLimitMdl.Text = "10";
            // 
            // TextLimitJava
            // 
            this.TextLimitJava.Location = new System.Drawing.Point(184, 32);
            this.TextLimitJava.Name = "TextLimitJava";
            this.TextLimitJava.Size = new System.Drawing.Size(40, 20);
            this.TextLimitJava.TabIndex = 7;
            this.TextLimitJava.Text = "10";
            // 
            // TextLimitVBA
            // 
            this.TextLimitVBA.Location = new System.Drawing.Point(184, 56);
            this.TextLimitVBA.Name = "TextLimitVBA";
            this.TextLimitVBA.Size = new System.Drawing.Size(40, 20);
            this.TextLimitVBA.TabIndex = 8;
            this.TextLimitVBA.Text = "10";
            // 
            // LabelRec
            // 
            this.LabelRec.Location = new System.Drawing.Point(8, 88);
            this.LabelRec.Name = "LabelRec";
            this.LabelRec.Size = new System.Drawing.Size(336, 16);
            this.LabelRec.TabIndex = 9;
            // 
            // ButtonTestMDL
            // 
            this.ButtonTestMDL.Location = new System.Drawing.Point(240, 8);
            this.ButtonTestMDL.Name = "ButtonTestMDL";
            this.ButtonTestMDL.Size = new System.Drawing.Size(96, 24);
            this.ButtonTestMDL.TabIndex = 10;
            this.ButtonTestMDL.Text = "mdlDialog_open";
            this.ButtonTestMDL.Click += new System.EventHandler(this.ButtonTestMDL_Click);
            // 
            // ButtonTestMSDGN
            // 
            this.ButtonTestMSDGN.Location = new System.Drawing.Point(240, 32);
            this.ButtonTestMSDGN.Name = "ButtonTestMSDGN";
            this.ButtonTestMSDGN.Size = new System.Drawing.Size(96, 24);
            this.ButtonTestMSDGN.TabIndex = 11;
            this.ButtonTestMSDGN.Text = "DGN automation";
            this.ButtonTestMSDGN.Click += new System.EventHandler(this.ButtonTestMSDGN_Click);
            // 
            // NetForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(352, 109);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.ButtonTestMSDGN,
                                                                          this.ButtonTestMDL,
                                                                          this.LabelRec,
                                                                          this.TextLimitVBA,
                                                                          this.TextLimitJava,
                                                                          this.TextLimitMdl,
                                                                          this.label3,
                                                                          this.label2,
                                                                          this.label1,
                                                                          this.ButtonCallVba,
                                                                          this.ButtonJava,
                                                                          this.ButtonMdl});
            this.Name = "NetForm";
            this.Text = " . Net Form";
            this.Load += new System.EventHandler(this.NetForm_Load);
            this.ResumeLayout(false);

        }
		#endregion

		public int setLimitToNetForm (int limit)
		{
			this.LabelRec.Text= ".NET Form got  " + limit.ToString();
			return 0;
			
		}
		private void ButtonMdl_Click(object sender, System.EventArgs e)
		{
			//OnTransmitEventMdl(20);
			DLLWrap.dll_callMdlFunc(Convert.ToInt16(this.TextLimitMdl.Text));

		}

		private void ButtonJava_Click(object sender, System.EventArgs e)
		{
		   //OnTransmitEventJava(20);
			DLLWrap.dll_callJavaMethod(Convert.ToInt16(this.TextLimitJava.Text));
		}

		private void ButtonCallVba_Click(object sender, System.EventArgs e)
		{
		   OnTransmitEventVba(Convert.ToInt16(this.TextLimitVBA.Text));
		}

		private void NetForm_Load(object sender, System.EventArgs e)
		{
			Activate();
			Show();
		}

        private void ButtonTestMDL_Click(object sender, System.EventArgs e)
        {
             DLLWrap.mdlDialog_openInfoBox("message from .NET");
        
        }

        private void ButtonTestMSDGN_Click(object sender, System.EventArgs e)
        {
          msApps.Caption = "Caption Set by .NET";
          MicroStationDGN.View  msView;  
          msView = msApps.ActiveDesignFile.Views[1];
          msView.Zoom(2);
          msView.Redraw();
            

          MicroStationDGN.__ApplicationEvents_OnDesignFileClosedEventHandler
              DesignEventClose = new MicroStationDGN.__ApplicationEvents_OnDesignFileClosedEventHandler(OnDesignClose);

          MicroStationDGN.__ApplicationEvents_OnDesignFileOpenedEventHandler
               DesignEventOpen = new MicroStationDGN.__ApplicationEvents_OnDesignFileOpenedEventHandler(OnDesignOpen);

            msApps.OnDesignFileClosed += DesignEventClose;
            msApps.OnDesignFileOpened += DesignEventOpen;
           

        }
        static void OnDesignClose(String designName){
            DLLWrap.netFormRef.LabelRec.Text= ".NET recieved File Close event "+ designName;
        }
        static void OnDesignOpen(String designName)
        {
            DLLWrap.netFormRef.LabelRec.Text= ".NET recieved File Open event " + designName;
        }



		
	}
}
