/* ------------------------------------------------------------------------ */
/*                                                                          */
/*    FILE              : nativeLib.cpp                                     */
/*    PURPOSE           : DLL gateway to Java                               */
/*                                                                          */
/*    PART OF COMPONENT : interop communication                             */
/*    CREATED BY        : Stanislav Sumbera,                                */
/*    DATE              : 02/2002	                                        */
/*    E-MAIL            : stanislav@sumbera.com,ambrosa@mendelu.cz          */
/*    WWW               : http://www.sumbera.com                            */
/* ------------------------------------------------------------------------ */
#include "stdafx.h"
#include "JavaJni.h"
#include "Mdlgo.h"
#include "Vbago.h"
#include "Netgo.h"


HANDLE moduleH;

/*----------------------------------------------------------*/
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason,
                    LPVOID lpReserved)
/*----------------------------------------------------------*/
{
 moduleH = hModule;

      

   return TRUE; // dll entry point
}

//----------------------------------------------------------
Public HWND getMSWnd 
(
 void
)
//----------------------------------------------------------
// Function to get MicroStation window handler
{
 HWND        hWndT;
 char        className[40];
 DWORD       hWndprocess; // window assiciated process

 for (hWndT = GetWindow(GetDesktopWindow(), GW_CHILD); hWndT;
      hWndT = GetWindow(hWndT, GW_HWNDNEXT))
      if ((GetClassName(hWndT, className, 40)) && 
          (!lstrcmpi(className, "MstnTop"))      &&
          GetWindowThreadProcessId(hWndT,&hWndprocess) &&
          (hWndprocess ==  GetCurrentProcessId()))
           return hWndT;
 return NULL;
}

//----------------------------------------------------------
int JNICALL dll_callJavaMethod(short limit)
//----------------------------------------------------------
{
 JavaVM            *jvm;       // denotes a Java VM 
 JNIEnv            *env;       // pointer to java native interface 
 jsize             nVMs;

 char    message[255];
 sprintf(message,"Native Dll recieved value %d, continuing to JAVA ...",limit);
 ::MessageBox(getMSWnd(),message,"nativeLib",MB_OK);
   
 jint res = JNI_GetCreatedJavaVMs(&jvm,(jsize)1,&nVMs);
 res      = jvm->AttachCurrentThread((void**)&env,NULL);
 jclass    cls  = env->FindClass("JavaJni");
 jmethodID mid  = env->GetMethodID(cls, "onMdlCall", "(S)I");
 jfieldID  fid  = env->GetStaticFieldID(cls, "javaObj", "LJavaJni;");
 jobject   obj  = env->GetStaticObjectField(cls, fid);
 return   env->CallIntMethod(obj, mid,limit); // call the Java method
    
}

// =============  CALL FROM JAVA TO MDL  ======================= 
//----------------------------------------------------------- 
JNIEXPORT jint JNICALL Java_JavaJni_callMdlFunc 
 (JNIEnv *, jobject jthis , jshort limit)
//----------------------------------------------------------- 
{
    return (jint) dll_callMdlFunc( limit); //  call to mdl
}

// =============  CALL FROM JAVA TO VBA  ======================= 
//----------------------------------------------------------- 
JNIEXPORT jint JNICALL Java_JavaJni_callVbaMethod 
 (JNIEnv *, jobject jthis , jshort limit)
//----------------------------------------------------------- 
{
    return (jint) dll_callVbaMethod(limit); //  call to Vba
}

// =============  CALL FROM JAVA TO NET  ======================= 
//----------------------------------------------------------- 
JNIEXPORT jint JNICALL Java_JavaJni_callNetMethod 
 (JNIEnv *, jobject jthis , jshort limit)
//----------------------------------------------------------- 
{
    return (jint) dll_callNetMethod(limit); //  call to Net
}
